﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Camera
{
    class Asteroid
    {

        public Vector3 pos;
        public Vector3 vel;
        public Quaternion orient;
        public Vector3 L;

        public Asteroid(Vector3 startpos, Vector3 startvel, Quaternion q, Vector3 sL)
        {
            pos = startpos;
            vel = startvel;
            orient = q;
            L = sL;
        }

        public void Update(GameTime gt)
        {
            orient = orient + (Quaternion.Multiply(new Quaternion(0.5f * L, 0), orient)) * (float)gt.ElapsedGameTime.TotalSeconds;
            orient.Normalize();
        }

        public void Draw(Model m, Matrix projection, Matrix view)
        {
            Matrix world = Matrix.Identity;
            Matrix w, rotmat;
           
            rotmat = Matrix.CreateFromQuaternion(orient);
            w = Matrix.CreateScale(0.01f) * rotmat * Matrix.CreateTranslation(pos);
            
            foreach (ModelMesh mesh in m.Meshes)
            {
                foreach (BasicEffect be in mesh.Effects)
                {
                    be.EnableDefaultLighting();
                    be.Projection = projection;
                    be.View = view;
                    be.World = w *
                        mesh.ParentBone.Transform;

                }
                mesh.Draw();
            }
         
            
        }

    }
}
