﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using System.Text;

namespace Camera
{

    class Camera
    {
        public Vector3 pos, up, front, frontcons, upcons;

        public Quaternion q;

        float speed = 0.1f;
        float rotrate = 0.01f;

        public Camera()
        {
            pos = Vector3.Zero;
            up = Vector3.Up;

            upcons = up;

            front = Vector3.Forward;
            frontcons = front;

            pos.Z = -3.0f;
            q = Quaternion.Identity;
            //this.Turn(Quaternion.CreateFromAxisAngle(up,(float)Math.PI));
        }

        private void Turn(Quaternion qrot)
        {
            q = Quaternion.Multiply(qrot, q);
            q.Normalize();
            front = Vector3.Transform(frontcons, q);
            up = Vector3.Transform(upcons, q);
        }

        public void turnR()
        {
            Quaternion turn = Quaternion.CreateFromAxisAngle(up, -rotrate);
            Turn(turn);
        }

        public void turnL()
        {
            Quaternion turn = Quaternion.CreateFromAxisAngle(up, rotrate);
            Turn(turn);
        }

        public void Climb()
        {
            Vector3 side = Vector3.Cross(front, up);
            Quaternion turn = Quaternion.CreateFromAxisAngle(side, rotrate);
            Turn(turn);
        }
        public void Dive()
        {
            Vector3 side = Vector3.Cross(front, up);
            Quaternion turn = Quaternion.CreateFromAxisAngle(side, -rotrate);
            Turn(turn);
        }
        public void rollR()
        {
            Quaternion turn = Quaternion.CreateFromAxisAngle(front, -rotrate);
            Turn(turn);

        }
        public void rollL()
        {
            Quaternion turn = Quaternion.CreateFromAxisAngle(front, rotrate);
            Turn(turn);
        }

        public void run()
        {
            pos += front * speed;
        }

        public Matrix getView()
        {
            Matrix view = Matrix.CreateLookAt(pos, pos + front, up);
            return view;
        }

        public void strafeR()
        {
            pos += Vector3.Cross(front, up);
        }

        public void strafeL()
        {
            pos -= Vector3.Cross(front, up);
        }

    }
}